// 
// bbs.chx

#include "stdafx.h"
#include "..\common\WebUtil.h"
#include "db.h"


//void	Error(MyVarMem* pRes, char* pszErrorString);
inline char AtoH( char c );
BOOL	MyGetFileName(char* pszSrcFilePath, char* pszDstFileName, int nFileNameLen);
BOOL	MakeItem( MyVarMem* pBody, MyVarMem* pRes, MyVarMem* pDst);
void	GetQueryStringValue( const char* pszQS, const char* pszKey, char* pszValue, int nValueLen );
BOOL	GetScriptCurrentDir(MyHash* pEnv, char* pszDstName, int nDstNameLen);
HANDLE	CreateFileMBCS(LPCSTR lpFileName, DWORD dwDesiredAccess, 
DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, 
DWORD dwCreationDispostion , DWORD dwFlagsAndAttributes, HANDLE hTemplateFile );

// ----------------------------------------------------------------------------
// CreateFileMBCS
// ----------------------------------------------------------------------------
HANDLE CreateFileMBCS(LPCSTR lpFileName, DWORD dwDesiredAccess, 
		DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, 
		DWORD dwCreationDispostion , DWORD dwFlagsAndAttributes, HANDLE hTemplateFile )
{
	TCHAR* pT;
	int nTlen;
	HANDLE hRet;

	if( lpFileName == NULL )
		return INVALID_HANDLE_VALUE;

	nTlen = MultiByteToWideChar(CP_ACP, 0, lpFileName, -1, NULL, 0);

	pT = new TCHAR[nTlen+sizeof(TCHAR)];
	if( pT == NULL )
	{
		return INVALID_HANDLE_VALUE;
	}

	nTlen = MultiByteToWideChar(CP_ACP, 0, lpFileName, -1, pT, nTlen);

	hRet =  CreateFile(
		pT, dwDesiredAccess, dwShareMode, lpSecurityAttributes, 
		dwCreationDispostion ,dwFlagsAndAttributes, hTemplateFile );

	delete[] pT;
	
	return hRet;

}

// ----------------------------------------------------------------------------
// FileMyVarMem֗
// ----------------------------------------------------------------------------
BOOL FileToMyVarMem(char* pszFileName, MyVarMem* pVM)
{
	DWORD dwReadBytes;
	HANDLE hFile;
	char	szBuf[256] = {0};

	if( pszFileName == NULL || pVM == NULL )
		return FALSE;

	hFile = CreateFileMBCS(pszFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	
	if( hFile == INVALID_HANDLE_VALUE )
		return FALSE;

	do
	{
		BOOL bResult;
		bResult = ReadFile( hFile, szBuf, 256, &dwReadBytes, NULL );
		if (bResult == 0 || dwReadBytes == 0)
			break;

		pVM->Add(szBuf, dwReadBytes);

	}while(1);

	CloseHandle( hFile );
	return TRUE;
}

// ----------------------------------------------------------------------------
// HTML wb_[o
// ----------------------------------------------------------------------------
void HTML_HEADER( MyHash* pEnv, MyVarMem* pRes )
{
	pRes->Add( 
		"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=shift_jis\">\n"
		"<HTML><HEAD>\n"
		"<TITLE>CEHTTP BBS</TITLE>\n"
		"</HEAD>\n"
		"<BODY BGCOLOR=#FFFFFF>\n");
	return;
}

// ----------------------------------------------------------------------------
// FORM ̏
// name		: O
// email	: [AhX
// subject	: 薼
// body		; e
// ----------------------------------------------------------------------------
void HTML_FROM( MyHash* pEnv, MyVarMem* pRes )
{
	char* pszScriptName = pEnv->GetValueI("SCRIPT_NAME");

	if( pszScriptName == NULL )
		return;

	pRes->Add("<form method=POST action=\"");
	pRes->Add(pszScriptName);
	pRes->Add("\"><TT>");

	pRes->Add(
		"e <input type=text name=\"name\" size=20 value=\"\" maxlength=24><br>"
		"[ <input type=text name=\"email\" size=30 value=\"\"><br>"
		"@ <input type=text name=\"subject\" size=30><br>"
		"@e <br></TT>"
		"<textarea name=\"body\" rows=5 cols=80></textarea>"
		"<input type=submit value=\"     e     \"><input type=reset value=\"\">"
		"</form>"
		);
}

// ----------------------------------------------------------------------------
// HTML tb^[o
// ----------------------------------------------------------------------------
void HTML_FOOTER( MyHash* pEnv, MyVarMem* pRes )
{
	pRes->Add(
		"<P><A HREF=\"http://www001.upp.so-net.ne.jp/ishi/\">CEHTTP BBS by IshiSoft</A>"
		"</BODY></HTML>\n");
}

// ----------------------------------------------------------------------------
// JgfBNg擾
// ----------------------------------------------------------------------------
BOOL GetScriptCurrentDir(MyHash* pEnv, char* pszDstName, int nDstNameLen)
{
	//SCRIPT_NAME=/scripts/sample.chx
	//DOCUMENT_ROOT=\wwwroot

	char* pszDocmentRoot = pEnv->GetValue("DOCUMENT_ROOT");
	char* pszScriptName = pEnv->GetValue("SCRIPT_NAME");

	if( !pszDocmentRoot || !pszScriptName )
		return FALSE;

	if( !pszDstName || nDstNameLen == 0 )
		return FALSE;

	int nDocmentRoot = strlen(pszDocmentRoot);
	int nScriptName = strlen(pszScriptName);

	if( nDocmentRoot + nScriptName >= nDstNameLen )
		return FALSE;
	
	strcpy(pszDstName, pEnv->GetValue("DOCUMENT_ROOT"));
	strcat(pszDstName, pEnv->GetValue("SCRIPT_NAME"));

	char* p = pszDstName;

	do{
		if( *p == '/' )
			*p = '\\';
	}while( *p++ != '\0' );

	p--;

	while( *p != '\\' )
	{
		if( p == pszDstName ) break;

		*p-- = '\0';
	};

	return TRUE;
}


// ----------------------------------------------------------------------------
// t@C؂oDBƂ
// ----------------------------------------------------------------------------
BOOL MyGetFileName(char* pszSrcFilePath, char* pszDstFileName, int nFileNameLen)
{
	int ii = 0;

	if( pszSrcFilePath == NULL || pszDstFileName == NULL || nFileNameLen == 0 )
		return FALSE;

	// "c:\xxxx\xxxx\xxxx.abc"
	char* p = pszSrcFilePath + 1;

	// pŌ܂Ői߂
	while( *p != '\"' && *p != '\0' )
		p++;

	//*p = '\0';
	p--;

	while( *p != '\\' && *p != '\0' && *p != '\"' && *p != '/' )
		p--;

	p++;

	strcpy( pszDstFileName, "CEHTTP_" );
	nFileNameLen -= 7;
	pszDstFileName += 7;

	while( *p != '\"' && *p != '\0' && ii++ < nFileNameLen )
		*pszDstFileName++ = *p++;

	*pszDstFileName = '\0';

	return TRUE;
}

// ----------------------------------------------------------------------------
// QUERY_STRING lǂݏo
// keyɂ "xxxx=" Ƃ=܂Ŋ܂߂邱
// ----------------------------------------------------------------------------
void GetQueryStringValue( const char* pszQS, const char* pszKey, char* pszValue, int nValueLen )
{
	if( pszQS == NULL || pszKey == NULL || pszValue == NULL || nValueLen == 0 )
		return;

	memset( pszValue, 0, nValueLen );

	char* p = strstr( pszQS, pszKey );
	if( p == NULL )
		return;

	while( (*p != '=') && (*p != '\0') ) *p++;

	if( *p == '\0' )
		return;

	p++;

	for( ;(*p != '&') && (*p != '\0') && (nValueLen); p++, pszValue++, nValueLen-- )
	{
		*pszValue = *p;
	}

	UnEscape( pszValue );
}

//*****************************************************************************
//
// fhChx
//	@etail
//		CGI[gDoc[gzɂ邱ƂKvƂȂ܂
//		Ƃ ../<cgiroot>/cgi.cgiȂǂ͔F܂
//		Ăяoɂ..͎gȂ
//
//		ԓ͕KCRLFŉs܂B
//		sڂ́uContent-Type: vLqĂB
//
// ----------------------------------------------------------------------------
//
//	@param
//		MyHash*		pEnv		ϐ܂
//		MyVarMem*	pBody		POSTꂽꍇANGXg{fB܂
//		MyVarMem*	pRes		NCAgɕԂeǉ܂
//
//	@return
//		pResɋlߍ񂾃oCgԂĂB
//
//*****************************************************************************
int fnChx(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	CRITICAL_SECTION csMyCriticalSection;
	InitializeCriticalSection (&csMyCriticalSection);
	
	char	pszScriptName[256];
	TCHAR	ptszScriptName[256];
	char	pszErrBadScriptName[] = "Bad script name";
	char	pszKey[] = "SCRIPT_NAME";

	// --------------------------------------------------------------
	// db̍쐬
	// --------------------------------------------------------------
	if( MyGetFileName( pEnv->GetValueI("SCRIPT_NAME"), pszScriptName, 256 ) == FALSE )
	{
		Error( pRes, pszErrBadScriptName );
		return pRes->GetLength();
	}

	if( 0 == MultiByteToWideChar(CP_ACP, 0, pszScriptName, -1, ptszScriptName, 256) )
	{
		Error( pRes, pszErrBadScriptName );
		return pRes->GetLength();
	}

	// --------------------------------------------------------------
	// ݎ̏
	// --------------------------------------------------------------
	if( 0 == strcmp( pEnv->GetValue("REQUEST_METHOD"), "POST" ) )
	{
		if( !ItemAdd( ptszScriptName, pBody, pRes ) )
		{
			return pRes->GetLength();
		}

		pRes->Clear();
		pRes->Add("Location: ");
		pRes->Add(pEnv->GetValue("SCRIPT_NAME"));
		pRes->Add("\r\n\r\n");
//		pRes->Add("return");
		return pRes->GetLength();
	}


	char szDeleteId[16] = {0};
	DWORD dwDeleteId;
	GetQueryStringValue( pEnv->GetValueI("QUERY_STRING"), "delete", szDeleteId, 12 );
	dwDeleteId = (unsigned long)atol( szDeleteId );
	// nDeleteId = HtoDWORD(szDeleteId);
	if( dwDeleteId )
	{
		if( !ItemDelete(ptszScriptName, dwDeleteId, pRes ) )
		{
			sprintf(szDeleteId,"%X", dwDeleteId);
			Error(pRes, szDeleteId);
			return pRes->GetLength();
		}		
	}
	// --------------------------------------------------------------
	char szStartRow[16] = {0};
	DWORD nStartRow = 0;
	GetQueryStringValue( pEnv->GetValueI("QUERY_STRING"), "row", szStartRow, 12 );
	nStartRow = (unsigned long)atol( szStartRow );
	// nStartRow = HtoDWORD( szStartRow );


	pRes->Clear();
	pRes->Add( "Content-Type: text/html; Charset=Shift_JIS\r\n\r\n" );

	// --------------------------------------------------------------
	// HTML ̍쐬
	// --------------------------------------------------------------
	char	szBuf[MAX_PATH] = {0};

	GetScriptCurrentDir(pEnv, szBuf, MAX_PATH - 40);
	strcat(szBuf, HTMLHEADFILE);

	if( FileToMyVarMem( szBuf, pRes ) == FALSE )
	{
		HTML_HEADER(pEnv, pRes);
		pRes->Add("\n<!-- ERROR READ FILE ");
		pRes->Add(szBuf);
		pRes->Add(" -->\n");
		HTML_FROM(pEnv, pRes);
	}
	
	ItemRead( ptszScriptName, pEnv, pBody, pRes, nStartRow );

	GetScriptCurrentDir(pEnv, szBuf, MAX_PATH - 40);
	strcat(szBuf, HTMLFOOTFILE);

	if( FileToMyVarMem( szBuf, pRes ) == FALSE )
	{
		HTML_FOOTER(pEnv, pRes);
	}
	return pRes->GetLength();

}


//*****************************************************************************
//
// DllMain
//
//*****************************************************************************
BOOL APIENTRY DllMain(
	HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

