#include "stdafx.h"
#include "..\common\WebUtil.h"
#include "db.h"

#define PL_TIME MAKELONG( CEVT_FILETIME, 0x0 )
#define PL_ITEM	MAKELONG( CEVT_BLOB, 0x1 )

#define ISKANJI(c) ((uchar)(c)>=0x80)

static BOOL MakeItem( MyVarMem* pBody, MyVarMem* pRes, MyVarMem* pDst);
static int	GetFormItem( MyVarMem* pBody, MyVarMem* pDst, char* pszKey );

// ----------------------------------------------------------------------------
// f[^
// ----------------------------------------------------------------------------
BOOL ItemAdd( TCHAR* ptszDBName, MyVarMem* pBody, MyVarMem* pRes )
{
	CEGUID ceguid;
	DWORD dwError;
	HANDLE hDB;
	CEDBASEINFO CEDBInfo;
	CEOID CeOid;

	CREATE_SYSTEMGUID( &ceguid );

	CeOid = 0;
	MyVarMem vmData;

	if( ptszDBName == NULL || pBody == NULL || pRes == NULL )
		return FALSE;

	// --------------------------------------------------------------
	// |Xgꂽf[^߂HTML
	// --------------------------------------------------------------
	if( FALSE == MakeItem( pBody, pRes, &vmData) )
		return FALSE;

	
	// --------------------------------------------------------------
	// Database open
	// --------------------------------------------------------------
	hDB = CeOpenDatabaseEx( &ceguid, &CeOid, ptszDBName, 0, CEDB_AUTOINCREMENT, NULL );

	if (hDB == INVALID_HANDLE_VALUE)
	{
		dwError = GetLastError();


		if (dwError == ERROR_NOT_ENOUGH_MEMORY)
		{
			Error(pRes, "Not enough memory");
			return FALSE;
		}
		else
		{
			// ------------------------------------------------------
			// Create new database named ptszDBName
			// ------------------------------------------------------
			memset(&CEDBInfo, 0, sizeof(CEDBInfo));

			CEDBInfo.dwFlags =
				CEDB_VALIDNAME
				| CEDB_VALIDTYPE
				| CEDB_VALIDDBFLAGS
				| CEDB_VALIDSORTSPEC;

			wcscpy (CEDBInfo.szDbaseName, ptszDBName);
			CEDBInfo.dwDbaseType = 0;
			CEDBInfo.wNumSortOrder = 1;

			CEDBInfo.rgSortSpecs[0].propid = PL_TIME;
			CEDBInfo.rgSortSpecs[0].dwFlags = CEDB_SORT_DESCENDING;


			CeOid = CeCreateDatabaseEx ( &ceguid, &CEDBInfo );

			if (CeOid == NULL)
			{
				Error( pRes, "ERROR: CeCreateDatabaseEx failed.");
				return FALSE;
			}
			else
			{
				hDB = CeOpenDatabaseEx (&ceguid, &CeOid, ptszDBName, 0, 0, NULL);
			}
		}
	}

	if (hDB == INVALID_HANDLE_VALUE)
	{
		Error( pRes, "ERROR: CeOpenDatabaseEx failed.");
		return FALSE;
	}

	// --------------------------------------------------------------
	// Database open success.
	// Create new record.
	// --------------------------------------------------------------

	CEPROPVAL  NewRecProps[2];
	MyVarMem	vmItem;
	CEOID		oidRecord = 0;
	char* pData = NULL;

	// time
	SYSTEMTIME	st;
	FILETIME	ft;
	GetLocalTime( &st );
	SystemTimeToFileTime( &st, &ft );

	NewRecProps[0].propid = PL_TIME;
	NewRecProps[0].wLenData = 0;
	NewRecProps[0].wFlags = 0;
	NewRecProps[0].val.filetime = ft;

	pData = (char*)vmData.GetBuffer();
	NewRecProps[1].propid = PL_ITEM;
	NewRecProps[1].wLenData = 0;
	NewRecProps[1].wFlags = 0;
	NewRecProps[1].val.blob.dwCount = strlen(pData)+1; // +NULL
	NewRecProps[1].val.blob.lpb  = (unsigned char*)pData;

	oidRecord = CeWriteRecordProps(hDB, 0, 2, &NewRecProps[0]);
	if( oidRecord == 0 )
	{
		Error(pRes, "Write Record Error");
		CloseHandle( hDB );
		return FALSE;
	}

	CloseHandle( hDB );
	return TRUE;



}

// ----------------------------------------------------------------------------
// f[^ǂݍ
// ----------------------------------------------------------------------------
BOOL ItemRead( TCHAR* ptszDBName, MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes, int nStartRow )
{
	if( ptszDBName == NULL || pEnv == NULL || pBody == NULL || pRes == NULL )
		return FALSE;
	
	int ii;

	HANDLE	hDB;
	DWORD	dwError;

	CEGUID	ceguid;
	CEOID	CeOid;

	CREATE_SYSTEMGUID( &ceguid );
	CeOid = 0;

	if(nStartRow < 0)
		nStartRow = 0;

	// --------------------------------------------------------------
	// DBI[v
	// --------------------------------------------------------------
	hDB = CeOpenDatabaseEx(&ceguid, &CeOid, ptszDBName, 0, CEDB_AUTOINCREMENT, NULL);

	if (hDB == INVALID_HANDLE_VALUE)
	{
		// ܂݂Ȃ
		return TRUE;
	}

	// --------------------------------------------------------------
	// R[hǂݏo
	// --------------------------------------------------------------
	WORD	wcPropID = 0;
	BYTE*		pBuffer = NULL;
	DWORD		dwcbBuffer;
	PCEPROPVAL	pVals;
	int			nRowCount = 0;
	int			ntmpStartRow = nStartRow;
	char*		pszLink = (char*)malloc(1024);

	if( pszLink == NULL )
		return FALSE;

	while ((CeOid = CeReadRecordProps(hDB, CEDB_ALLOWREALLOC, &wcPropID, NULL, &pBuffer, &dwcbBuffer)))
	{
		if( ntmpStartRow )
		{
			ntmpStartRow--;
			if( pBuffer != NULL )
			{
				LocalFree(pBuffer);
				pBuffer = NULL;
			}
			continue;
		}

		if( nRowCount++ >= MAX_ITEM_ROWS )
		{
			SetLastError( NO_ERROR );
			if( pBuffer != NULL )
			{
				LocalFree(pBuffer);
				pBuffer = NULL;
			}

			break;
		}


		pVals = (PCEPROPVAL)pBuffer;

		// BODY -----------------------------------------------------
		for( ii = 0; ii < wcPropID; ii++ )
		{
			if( pVals[ii].propid == PL_ITEM )
			{
				const char* p = (const char*)(pVals[ii].val.blob.lpb);
				pRes->Add( pVals[ii].val.blob.lpb, pVals[ii].val.blob.dwCount );
				sprintf( pszLink, "<A HREF=\"%s?deleteid=%d\">delete</A>", pEnv->GetValueI( "SCRIPT_NAME" ), CeOid );
				pRes->Add( pszLink );
				pRes->Add( "<HR><P>\n" );
			}
		}

		if( pBuffer != NULL )
		{
			LocalFree(pBuffer);
			pBuffer = NULL;
		}
	}

	dwError = GetLastError();

	sprintf( pszLink, "<A HREF=\"%s?\">TOP</A> ", pEnv->GetValueI( "SCRIPT_NAME" ) );

	if( dwError == NO_ERROR )
	{
		pRes->Add( pszLink );

		// [NEXT20]
		sprintf( pszLink, "<A HREF=\"%s?row=%d\">NEXT</A>", pEnv->GetValueI( "SCRIPT_NAME" ), nStartRow+MAX_ITEM_ROWS );
		pRes->Add( pszLink );
	}
	else if (dwError == ERROR_NO_MORE_ITEMS)
	{
		pRes->Add( pszLink );
	}
	else if (dwError == ERROR_INSUFFICIENT_BUFFER)
	{
		Error(pRes, "Re-allocation of database records failed.");
	}
	else
	{
		Error(pRes, "Other errors.");
	}

	// Close the database handle.

	if( pszLink != NULL ) free(pszLink);
	CloseHandle (hDB);

	return TRUE;
}

// ----------------------------------------------------------------------------
// f[^폜
// ----------------------------------------------------------------------------
BOOL ItemDelete( TCHAR* ptszDBName, CEOID oidRecord, MyVarMem* pRes )
{
	if( ptszDBName == NULL || pRes == NULL )
		return FALSE;

	HANDLE	hDB;
	CEGUID	ceguid;
	CEOID	CeOid;
	CREATE_SYSTEMGUID( &ceguid );
	CeOid = 0;
	char szBuf[256];

	hDB = CeOpenDatabaseEx(&ceguid, &CeOid, ptszDBName, 0, CEDB_AUTOINCREMENT, NULL);

	if (hDB == INVALID_HANDLE_VALUE)
	{
		CloseHandle( hDB );
		Error(pRes, "Open database Error");
		return FALSE;
	}
	else if( !CeDeleteRecord( hDB, oidRecord ) )
	{
		CloseHandle( hDB );
		sprintf( szBuf,
			"CeDeleteRecord was fail with error %d<BR>\n"
			"Database %d(%08X)<BR>\n"
			"Record %d(%08X)"
			, GetLastError()
			, hDB, hDB
			, oidRecord, oidRecord
			);
		Error(pRes, szBuf);
		return FALSE;
	}
	CloseHandle( hDB );
	return TRUE;
}

// ----------------------------------------------------------------------------
// |Xgꂽf[^ۑł`ɂB
// ----------------------------------------------------------------------------
static BOOL MakeItem( MyVarMem* pBody, MyVarMem* pRes, MyVarMem* pDst)
{
	char szName[30] = {0};
	char szMail[30] = {0};
	char szSubj[30] = {0};
	char szTimeStamp[30] = {0};
	
	SYSTEMTIME ts;

	int nMailLen = 0;
	MyVarMem* pvm = new MyVarMem;

	// Escape( (char*)pBody->GetBuffer() );

	// ----------------------------------------------------
	// name
	// ----------------------------------------------------
	if( GetFormItem(pBody, pvm, "name=") == 0 )
	{
		Error(pRes, "No Name.");
		delete pvm;
		return FALSE;
	}
	strncpy( szName, (const char*)pvm->GetBuffer(), 29 );
	if( ISKANJI(szName[28]) )
		szName[28] = '\0';

	// ----------------------------------------------------
	// mail
	// ----------------------------------------------------
	nMailLen = GetFormItem(pBody, pvm, "email=");
	strncpy( szMail, (const char*)pvm->GetBuffer(), 29 );
	if( ISKANJI(szMail[28]) )
		szMail[28] = '\0';
	
	// ----------------------------------------------------
	// subject
	// ----------------------------------------------------
	if( GetFormItem(pBody, pvm, "subject=") == 0 )
	{
		Error(pRes, "No Subject.");
		delete pvm;
		return FALSE;
	}
	memset( szSubj, 0, 30 );
	strncpy( szSubj, (const char*)pvm->GetBuffer(), 29 );
	if( ISKANJI(szSubj[28]) )
		szSubj[28] = '\0';

	GetLocalTime(&ts);
	sprintf( szTimeStamp, "%dN%d%d %d%d", ts.wYear, ts.wMonth, ts.wDay, ts.wHour, ts.wMinute );

	// ----------------------------------------------------
	// Write HTML File
	// ----------------------------------------------------
	pDst->Add( "<B> \r\n " );
	pDst->Add( szSubj );
	pDst->Add( " \r\n </B> " );
	
	if( nMailLen > 0 )
	{
		pDst->Add( " <A HREF=\"mailto:" );
		pDst->Add( szMail );
		pDst->Add( "\"> \r\n eҁF<B> \r\n " );
		pDst->Add( szName );
		pDst->Add( " \r\n </B></A>");
	}
	else
	{
		pDst->Add( "eҁF<B> \r\n " );
		pDst->Add( szName );
		pDst->Add( " \r\n </B> \r\n" );
	}
	pDst->Add( szTimeStamp );
	pDst->Add( " <P> \r\n " );

	if( GetFormItem(pBody, pvm, "body") == 0 )
	{
		Error(pRes, "No Body.");
		delete pvm;
		return FALSE;
	}
	pDst->Add( " \r\n <BLOCKQUOTE><TT> \r\n " );
	pDst->Add( pvm );
	pDst->Add( "" );
	pDst->Add( " \r\n </TT> </BLOCKQUOTE> \r\n " );

	delete pvm;
	return TRUE;
}

// ----------------------------------------------------------------------------
// tH[f[^lǂݎfR[h
// ----------------------------------------------------------------------------
static int GetFormItem( MyVarMem* pBody, MyVarMem* pDst, char* pszKey )
{
	char* pszBody = (char*)pBody->GetBuffer();
	char* pStart = strstr( pszBody, pszKey );
	MyVarMem pvmTmp;
	char c;

	if( pBody == NULL || pDst == NULL || pszKey == NULL || pszBody == NULL )
		return FALSE;

	pDst->Clear();

	if( pStart != NULL )
	{
		while( (*pStart != '=') && (*pStart != '\0') ) *pStart++;

		pStart++;

		if( *pStart == '&' || *pStart == '\0' )
		{
			pDst->Add( "", 1 );
			return 0;
		}

		do
		{
			pvmTmp.Add(pStart, 1);
			pStart++;
		}while( *pStart != '&' && *pStart != '\0' );

		pStart = (char*)pvmTmp.GetBuffer();

		UnEscape(pStart);

		do
		{
			c = *pStart++;
			
			if( !ISKANJI(c) )
			{
				switch(c)
				{
				case '<':
					pDst->Add( "&lt;" );
					break;

				case '>':
					pDst->Add( "&gt;" );
					break;

				case '&':
					pDst->Add( "&amp;" );
					break;
/*
				case ' ':
					pDst->Add( "&nbsp;" );
					break;
*/
				case '\n':
					pDst->Add( "<BR>\n" );
					break;

				case '\r':
					break;
					
				default:
					pDst->Add( &c, 1 );
				}
			}
			else
			{
				if( *pStart != '\0' )
				{
					pDst->Add( &c, 1 );
					c = *pStart++;
					pDst->Add( &c, 1 );
				}
				else
					break;
			}
		}
		while( *pStart != '\0' );
	}
	else
	{
		pDst->Add("(none)");
	}

	return strlen( (char*)pDst->GetBuffer() );
}

// ----------------------------------------------------------------------------
// G[\
// ----------------------------------------------------------------------------
void Error(MyVarMem* pRes, char* pszErrorString)
{
	pRes->Clear();
	pRes->Add("Content-Type: text/html\r\n\r\n");
	pRes->Add("<HTML><BODY>");
	pRes->Add(pszErrorString);
	pRes->Add("</BODY></HTML>");
}

